/*
 * The Relaxer artifact
 * Copyright (c) 2000-2004, ASAMI Tomoharu, All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * - Redistributions of source code must retain the above copyright
 *   notice, this list of conditions and the following disclaimer. 
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */
package com.netpotlet.boat;

/**
 * DefaultKeyboardFactory is generated by Relaxer based on keyboard.rng.
 *
 * @version keyboard.rng 1.0 (Mon Jan 26 11:51:56 JST 2004)
 * @author  Relaxer 1.1b (http://www.relaxer.org)
 */
public class DefaultKeyboardFactory extends AbstractKeyboardFactory {

    /**
     * Creates a default <code>StartKeyboard</code>.
     * This method is a hook method of the AbstractKeyboardFactory.
     *
     * @return StartKeyboard
     */
    public StartKeyboard createStartKeyboard() {
        return (new StartKeyboard());
    }

    /**
     * Creates a default <code>StartKeyboardKey</code>.
     * This method is a hook method of the AbstractKeyboardFactory.
     *
     * @return StartKeyboardKey
     */
    public StartKeyboardKey createStartKeyboardKey() {
        return (new StartKeyboardKey());
    }

    /**
     * Creates a default <code>SizeSize1</code>.
     * This method is a hook method of the AbstractKeyboardFactory.
     *
     * @return SizeSize1
     */
    public SizeSize1 createSizeSize1() {
        return (new SizeSize1());
    }

    /**
     * Creates a default <code>Label</code>.
     * This method is a hook method of the AbstractKeyboardFactory.
     *
     * @return Label
     */
    public Label createLabel() {
        return (new Label());
    }

    /**
     * Creates a default <code>LabelType1</code>.
     * This method is a hook method of the AbstractKeyboardFactory.
     *
     * @return LabelType1
     */
    public LabelType1 createLabelType1() {
        return (new LabelType1());
    }

    /**
     * Creates a default <code>SizeSize2</code>.
     * This method is a hook method of the AbstractKeyboardFactory.
     *
     * @return SizeSize2
     */
    public SizeSize2 createSizeSize2() {
        return (new SizeSize2());
    }

    /**
     * Creates a default <code>LabelType2</code>.
     * This method is a hook method of the AbstractKeyboardFactory.
     *
     * @return LabelType2
     */
    public LabelType2 createLabelType2() {
        return (new LabelType2());
    }
}
