/*
 * The Relaxer artifact
 * Copyright (c) 2000-2004, ASAMI Tomoharu, All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * - Redistributions of source code must retain the above copyright
 *   notice, this list of conditions and the following disclaimer. 
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */
package com.netpotlet.boat;

import java.io.*;
import java.net.URL;
import javax.xml.parsers.*;
import org.w3c.dom.*;
import org.xml.sax.*;

/**
 * IKeyboardFactory is generated by Relaxer based on keyboard.rng.
 *
 * @version keyboard.rng 1.0 (Mon Jan 26 11:51:56 JST 2004)
 * @author  Relaxer 1.1b (http://www.relaxer.org)
 */
public interface IKeyboardFactory {
    /**
     * Sets a <b>errorHandler</b>.
     *
     * @param errorHandler
     */
    void setErrorHandler(org.xml.sax.ErrorHandler errorHandler);

    /**
     * Gets a <b>errorHandler</b>.
     *
     * @return org.xml.sax.ErrorHandler
     */
    org.xml.sax.ErrorHandler getErrorHandler();

    /**
     * Sets a <b>entityResolver</b>.
     *
     * @param entityResolver
     */
    void setEntityResolver(org.xml.sax.EntityResolver entityResolver);

    /**
     * Gets a <b>entityResolver</b>.
     *
     * @return org.xml.sax.EntityResolver
     */
    org.xml.sax.EntityResolver getEntityResolver();

    /**
     * Sets a <b>baseUri</b>.
     *
     * @param baseUri
     */
    void setBaseUri(String baseUri);

    /**
     * Gets a <b>baseUri</b>.
     *
     * @return String
     */
    String getBaseUri();

    /**
     * Creates a <code>Object</code> by the File <code>file</code>.
     *
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return Object
     */
    Object create(File file) throws IOException, SAXException, ParserConfigurationException;

    /**
     * Creates a <code>Object</code> by the String representation of URI <code>uri</code>.
     *
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return Object
     */
    Object create(String uri) throws IOException, SAXException, ParserConfigurationException;

    /**
     * Creates a <code>Object</code> by the URL <code>url</code>.
     *
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return Object
     */
    Object create(URL url) throws IOException, SAXException, ParserConfigurationException;

    /**
     * Creates a <code>Object</code> by the InputStream <code>in</code>.
     *
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return Object
     */
    Object create(InputStream in) throws IOException, SAXException, ParserConfigurationException;

    /**
     * Creates a <code>Object</code> by the InputSource <code>is</code>.
     *
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return Object
     */
    Object create(InputSource is) throws IOException, SAXException, ParserConfigurationException;

    /**
     * Creates a <code>Object</code> by the Reader <code>reader</code>.
     *
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return Object
     */
    Object create(Reader reader) throws IOException, SAXException, ParserConfigurationException;

    /**
     * Creates a <code>Object</code> by the Object <code>source</code>.
     *
     * @param source
     * @return Object
     */
    Object create(Object source);

    /**
     * Creates a <code>Object</code> by the Document <code>dom</code>.
     *
     * @param doc
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return Object
     */
    Object create(Document doc) throws IOException, SAXException, ParserConfigurationException;

    /**
     * Creates a <code>Object</code> by the Element <code>element</code>.
     *
     * @param element
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return Object
     */
    Object create(Element element) throws IOException, SAXException, ParserConfigurationException;

    /**
     * Creates a <code>StartKeyboard</code> by the File <code>file</code>.
     *
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return StartKeyboard
     */
    StartKeyboard createStartKeyboard(File file) throws IOException, SAXException, ParserConfigurationException;

    /**
     * Creates a <code>StartKeyboardKey</code> by the File <code>file</code>.
     *
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return StartKeyboardKey
     */
    StartKeyboardKey createStartKeyboardKey(File file) throws IOException, SAXException, ParserConfigurationException;

    /**
     * Creates a <code>SizeSize1</code> by the File <code>file</code>.
     *
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return SizeSize1
     */
    SizeSize1 createSizeSize1(File file) throws IOException, SAXException, ParserConfigurationException;

    /**
     * Creates a <code>Label</code> by the File <code>file</code>.
     *
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return Label
     */
    Label createLabel(File file) throws IOException, SAXException, ParserConfigurationException;

    /**
     * Creates a <code>LabelType1</code> by the File <code>file</code>.
     *
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return LabelType1
     */
    LabelType1 createLabelType1(File file) throws IOException, SAXException, ParserConfigurationException;

    /**
     * Creates a <code>StartKeyboard</code>
     * by the String representation of URI <code>uri</code>.
     *
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return StartKeyboard
     */
    StartKeyboard createStartKeyboard(String uri) throws IOException, SAXException, ParserConfigurationException;

    /**
     * Creates a <code>StartKeyboardKey</code>
     * by the String representation of URI <code>uri</code>.
     *
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return StartKeyboardKey
     */
    StartKeyboardKey createStartKeyboardKey(String uri) throws IOException, SAXException, ParserConfigurationException;

    /**
     * Creates a <code>SizeSize1</code>
     * by the String representation of URI <code>uri</code>.
     *
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return SizeSize1
     */
    SizeSize1 createSizeSize1(String uri) throws IOException, SAXException, ParserConfigurationException;

    /**
     * Creates a <code>Label</code>
     * by the String representation of URI <code>uri</code>.
     *
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return Label
     */
    Label createLabel(String uri) throws IOException, SAXException, ParserConfigurationException;

    /**
     * Creates a <code>LabelType1</code>
     * by the String representation of URI <code>uri</code>.
     *
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return LabelType1
     */
    LabelType1 createLabelType1(String uri) throws IOException, SAXException, ParserConfigurationException;

    /**
     * Creates a <code>StartKeyboard</code> by the URL <code>url</code>.
     *
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return StartKeyboard
     */
    StartKeyboard createStartKeyboard(URL url) throws IOException, SAXException, ParserConfigurationException;

    /**
     * Creates a <code>StartKeyboardKey</code> by the URL <code>url</code>.
     *
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return StartKeyboardKey
     */
    StartKeyboardKey createStartKeyboardKey(URL url) throws IOException, SAXException, ParserConfigurationException;

    /**
     * Creates a <code>SizeSize1</code> by the URL <code>url</code>.
     *
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return SizeSize1
     */
    SizeSize1 createSizeSize1(URL url) throws IOException, SAXException, ParserConfigurationException;

    /**
     * Creates a <code>Label</code> by the URL <code>url</code>.
     *
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return Label
     */
    Label createLabel(URL url) throws IOException, SAXException, ParserConfigurationException;

    /**
     * Creates a <code>LabelType1</code> by the URL <code>url</code>.
     *
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return LabelType1
     */
    LabelType1 createLabelType1(URL url) throws IOException, SAXException, ParserConfigurationException;

    /**
     * Creates a <code>StartKeyboard</code> by the InputStream <code>in</code>.
     *
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return StartKeyboard
     */
    StartKeyboard createStartKeyboard(InputStream in) throws IOException, SAXException, ParserConfigurationException;

    /**
     * Creates a <code>StartKeyboardKey</code> by the InputStream <code>in</code>.
     *
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return StartKeyboardKey
     */
    StartKeyboardKey createStartKeyboardKey(InputStream in) throws IOException, SAXException, ParserConfigurationException;

    /**
     * Creates a <code>SizeSize1</code> by the InputStream <code>in</code>.
     *
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return SizeSize1
     */
    SizeSize1 createSizeSize1(InputStream in) throws IOException, SAXException, ParserConfigurationException;

    /**
     * Creates a <code>Label</code> by the InputStream <code>in</code>.
     *
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return Label
     */
    Label createLabel(InputStream in) throws IOException, SAXException, ParserConfigurationException;

    /**
     * Creates a <code>LabelType1</code> by the InputStream <code>in</code>.
     *
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return LabelType1
     */
    LabelType1 createLabelType1(InputStream in) throws IOException, SAXException, ParserConfigurationException;

    /**
     * Creates a <code>StartKeyboard</code> by the InputSource <code>is</code>.
     *
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return StartKeyboard
     */
    StartKeyboard createStartKeyboard(InputSource is) throws IOException, SAXException, ParserConfigurationException;

    /**
     * Creates a <code>StartKeyboardKey</code> by the InputSource <code>is</code>.
     *
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return StartKeyboardKey
     */
    StartKeyboardKey createStartKeyboardKey(InputSource is) throws IOException, SAXException, ParserConfigurationException;

    /**
     * Creates a <code>SizeSize1</code> by the InputSource <code>is</code>.
     *
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return SizeSize1
     */
    SizeSize1 createSizeSize1(InputSource is) throws IOException, SAXException, ParserConfigurationException;

    /**
     * Creates a <code>Label</code> by the InputSource <code>is</code>.
     *
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return Label
     */
    Label createLabel(InputSource is) throws IOException, SAXException, ParserConfigurationException;

    /**
     * Creates a <code>LabelType1</code> by the InputSource <code>is</code>.
     *
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return LabelType1
     */
    LabelType1 createLabelType1(InputSource is) throws IOException, SAXException, ParserConfigurationException;

    /**
     * Creates a <code>StartKeyboard</code> by the Reader <code>reader</code>.
     *
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return StartKeyboard
     */
    StartKeyboard createStartKeyboard(Reader reader) throws IOException, SAXException, ParserConfigurationException;

    /**
     * Creates a <code>StartKeyboardKey</code> by the Reader <code>reader</code>.
     *
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return StartKeyboardKey
     */
    StartKeyboardKey createStartKeyboardKey(Reader reader) throws IOException, SAXException, ParserConfigurationException;

    /**
     * Creates a <code>SizeSize1</code> by the Reader <code>reader</code>.
     *
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return SizeSize1
     */
    SizeSize1 createSizeSize1(Reader reader) throws IOException, SAXException, ParserConfigurationException;

    /**
     * Creates a <code>Label</code> by the Reader <code>reader</code>.
     *
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return Label
     */
    Label createLabel(Reader reader) throws IOException, SAXException, ParserConfigurationException;

    /**
     * Creates a <code>LabelType1</code> by the Reader <code>reader</code>.
     *
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return LabelType1
     */
    LabelType1 createLabelType1(Reader reader) throws IOException, SAXException, ParserConfigurationException;

    /**
     * Creates a <code>StartKeyboard</code>.
     *
     * @return StartKeyboard
     */
    StartKeyboard createStartKeyboard();

    /**
     * Creates a <code>StartKeyboardKey</code>.
     *
     * @return StartKeyboardKey
     */
    StartKeyboardKey createStartKeyboardKey();

    /**
     * Creates a <code>SizeSize1</code>.
     *
     * @return SizeSize1
     */
    SizeSize1 createSizeSize1();

    /**
     * Creates a <code>Label</code>.
     *
     * @return Label
     */
    Label createLabel();

    /**
     * Creates a <code>LabelType1</code>.
     *
     * @return LabelType1
     */
    LabelType1 createLabelType1();

    /**
     * Creates a <code>StartKeyboard</code> by the StartKeyboard <code>source</code>.
     *
     * @param source
     * @return StartKeyboard
     */
    StartKeyboard createStartKeyboard(StartKeyboard source);

    /**
     * Creates a <code>StartKeyboardKey</code> by the StartKeyboardKey <code>source</code>.
     *
     * @param source
     * @return StartKeyboardKey
     */
    StartKeyboardKey createStartKeyboardKey(StartKeyboardKey source);

    /**
     * Creates a <code>SizeSize1</code> by the SizeSize1 <code>source</code>.
     *
     * @param source
     * @return SizeSize1
     */
    SizeSize1 createSizeSize1(SizeSize1 source);

    /**
     * Creates a <code>Label</code> by the Label <code>source</code>.
     *
     * @param source
     * @return Label
     */
    Label createLabel(Label source);

    /**
     * Creates a <code>LabelType1</code> by the LabelType1 <code>source</code>.
     *
     * @param source
     * @return LabelType1
     */
    LabelType1 createLabelType1(LabelType1 source);

    /**
     * Creates a <code>StartKeyboard</code> by the Document <code>doc</code>.
     *
     * @param doc
     * @return StartKeyboard
     */
    StartKeyboard createStartKeyboard(Document doc);

    /**
     * Creates a <code>StartKeyboardKey</code> by the Document <code>doc</code>.
     *
     * @param doc
     * @return StartKeyboardKey
     */
    StartKeyboardKey createStartKeyboardKey(Document doc);

    /**
     * Creates a <code>SizeSize1</code> by the Document <code>doc</code>.
     *
     * @param doc
     * @return SizeSize1
     */
    SizeSize1 createSizeSize1(Document doc);

    /**
     * Creates a <code>Label</code> by the Document <code>doc</code>.
     *
     * @param doc
     * @return Label
     */
    Label createLabel(Document doc);

    /**
     * Creates a <code>LabelType1</code> by the Document <code>doc</code>.
     *
     * @param doc
     * @return LabelType1
     */
    LabelType1 createLabelType1(Document doc);

    /**
     * Creates a <code>StartKeyboard</code> by the Element <code>element</code>.
     *
     * @param element
     * @return StartKeyboard
     */
    StartKeyboard createStartKeyboard(Element element);

    /**
     * Creates a <code>StartKeyboardKey</code> by the Element <code>element</code>.
     *
     * @param element
     * @return StartKeyboardKey
     */
    StartKeyboardKey createStartKeyboardKey(Element element);

    /**
     * Creates a <code>SizeSize1</code> by the Element <code>element</code>.
     *
     * @param element
     * @return SizeSize1
     */
    SizeSize1 createSizeSize1(Element element);

    /**
     * Creates a <code>Label</code> by the Element <code>element</code>.
     *
     * @param element
     * @return Label
     */
    Label createLabel(Element element);

    /**
     * Creates a <code>LabelType1</code> by the Element <code>element</code>.
     *
     * @param element
     * @return LabelType1
     */
    LabelType1 createLabelType1(Element element);

    /**
     * Creates a <code>StartKeyboard</code> by the Stack <code>stack</code>.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     * @return StartKeyboard
     */
    StartKeyboard createStartKeyboard(RStack stack);

    /**
     * Creates a <code>StartKeyboardKey</code> by the Stack <code>stack</code>.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     * @return StartKeyboardKey
     */
    StartKeyboardKey createStartKeyboardKey(RStack stack);

    /**
     * Creates a <code>SizeSize1</code> by the Stack <code>stack</code>.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     * @return SizeSize1
     */
    SizeSize1 createSizeSize1(RStack stack);

    /**
     * Creates a <code>Label</code> by the Stack <code>stack</code>.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     * @return Label
     */
    Label createLabel(RStack stack);

    /**
     * Creates a <code>LabelType1</code> by the Stack <code>stack</code>.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     * @return LabelType1
     */
    LabelType1 createLabelType1(RStack stack);

    /**
     * Creates a <code>SizeSize2</code> by the Element <code>element</code>.
     *
     * @return SizeSize2
     */
    SizeSize2 createSizeSize2();

    /**
     * Creates a <code>LabelType2</code> by the Element <code>element</code>.
     *
     * @return LabelType2
     */
    LabelType2 createLabelType2();

    /**
     * Creates a <code>SizeSize2</code> by the Stack <code>stack</code>.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     * @return SizeSize2
     */
    SizeSize2 createSizeSize2(RStack stack);

    /**
     * Creates a <code>LabelType2</code> by the Stack <code>stack</code>.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     * @return LabelType2
     */
    LabelType2 createLabelType2(RStack stack);

    /**
     * Creates a <code>SizeSize2</code> by the object <code>source</code>.
     * This method is a template method for concrete classes.
     *
     * @param source
     * @return SizeSize2
     */
    SizeSize2 createSizeSize2(SizeSize2 source);

    /**
     * Creates a <code>LabelType2</code> by the object <code>source</code>.
     * This method is a template method for concrete classes.
     *
     * @param source
     * @return LabelType2
     */
    LabelType2 createLabelType2(LabelType2 source);

    /**
     * Creates a <code>RString</code> by the Stack <code>stack</code>.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     * @return RString
     */
    RString createRString(RStack stack);
}
