/*
 * : 2003/12/29
 *
 * 줿Ȥƥץ졼Ȥѹ뤿
 * ɥ >  > Java >  > ɤȥ
 */
package com.netpotlet.test;

import java.io.FileNotFoundException;
import java.io.File;
import java.io.IOException;

import javax.xml.parsers.ParserConfigurationException;

import org.xml.sax.SAXException;

import com.netpotlet.boat.ILabelMixed;
import com.netpotlet.boat.ISizeChoice;
import com.netpotlet.boat.Label;
import com.netpotlet.boat.LabelType1;
import com.netpotlet.boat.LabelType2;
import com.netpotlet.boat.StartKeyboard;
import com.netpotlet.boat.StartKeyboardKey;

/**
 * @author yoko
 *
 * 줿Ȥƥץ졼Ȥѹ뤿
 * ɥ >  > Java >  > ɤȥ
 */
public class RelaxerReader {
	private StartKeyboard keyboard;

	RelaxerReader(String filename)
		throws
			FileNotFoundException,
			IOException,
			SAXException,
			ParserConfigurationException {
		keyboard = new StartKeyboard(new File(filename));
	}

	StartKeyboard getKeyboard() {
		return keyboard;
	}

	private void report() {
		String newline = System.getProperty("line.separator");
		String defaultSize = "small";

		StartKeyboardKey[] keys = keyboard.getStartKeyboardKey();
		StringBuffer sb = new StringBuffer();
		for (int i = 0; i < keys.length; i++) {
			StartKeyboardKey key = keys[i];
			sb.append("size: ");
			ISizeChoice sizeChoice = key.getSize();
			if (sizeChoice == null) {
				sb.append(defaultSize);
			} else {
				sb.append(sizeChoice.getContent());
			}
			Label[] labels = key.getLabel();
			for (int j = 0; j < labels.length; j++) {
				sb.append(" [");
				Label label = labels[j];
				if (label.getDefault()) {
					sb.append("(default)");
				}
				ILabelMixed[] mixedLabels = label.getContent();
				for (int k = 0; k < mixedLabels.length; k++) {
					ILabelMixed labelMixed = mixedLabels[k];
					if ((labelMixed instanceof LabelType1)
						|| (labelMixed instanceof LabelType2)) {
						sb.append("type: ");
						sb.append(labelMixed.getContent());
						sb.append("  ");
					} else {
						String contents = labelMixed.getContent();
						sb.append("label: ");
						sb.append(contents);
						sb.append("  ");
					}
				}
				sb.append("]");
			}
			sb.append(newline);
		}
		System.out.println(new String(sb));
	}

	public static void main(String[] args) throws Exception {
		if (args.length < 1) {
			throw new Exception("arguments are not enough");
		}
		RelaxerReader reader = new RelaxerReader(args[0]);
		reader.report();
	}
}
